﻿& 'C:\Program Files (x86)\Hantek6000\Scope.exe'                                 #付属アプリを起動する
while ( (Get-Process | Where-Object {$_.Name -match "scope"}) -eq $null ){}        #"scope"というプロセスが現れるまで待つ
start-sleep -Milliseconds 3000
[System.Windows.Forms.SendKeys]::SendWait("(% X)")
[System.Windows.Forms.SendKeys]::SendWait("%f")
start-sleep -Milliseconds 10
[System.Windows.Forms.SendKeys]::SendWait("{down 3}")
start-sleep -Milliseconds 10
[System.Windows.Forms.SendKeys]::SendWait("{enter}")
start-sleep -Milliseconds 10
$retry_cnt = 0
Set-Clipboard -Value "neko"
do{
    
    [System.Windows.Forms.SendKeys]::SendWait(".")
    [System.Windows.Forms.SendKeys]::SendWait("^a")
    [System.Windows.Forms.SendKeys]::SendWait("^c")
    start-sleep -Milliseconds 100
    $clip_board = Get-Clipboard -Format Text
    $retry_cnt = $retry_cnt + 1
    if( $retry_cnt -gt 10 ){
        break
    }
}while( $clip_board -ne "." )
start-sleep -Milliseconds 10
[System.Windows.Forms.SendKeys]::SendWait("^a")
[System.Windows.Forms.SendKeys]::SendWait("^x")
[System.Windows.Forms.SendKeys]::SendWait("ac100.set")                            #設定ファイルを読み込む
start-sleep -Milliseconds 10
[System.Windows.Forms.SendKeys]::SendWait("{enter}")
start-sleep -Milliseconds 100
[System.Windows.Forms.SendKeys]::SendWait("^r")
start-sleep -Milliseconds 1000
        
while ($true){
    if( ( Get-Process | Where-Object {$_.Name -match "scope"} ) -eq $null ){    #付属アプリのプロセスが存在しなければ終了する
        exit
    }
    $wait_time = ( 55.0 - [double](Get-Date -Format "ss" ) )*1000.0
    if( $wait_time -lt 0.0 ){
        $wait_time = 0
    }
    start-sleep -Milliseconds $wait_time                                        #動作開始5秒前までスリープ
    while( ( Get-Date -Format "ss" ) -ne "00" ){}                                #秒が"00"になるまで待つ
    $data_point = Get-Date -Format "yy/MM/dd HH:mm:ss"                            #波形の取得時刻を記録
    [System.Windows.Forms.SendKeys]::SendWait("^r")                                #Ctrl+rで波形の取得開始
    start-sleep -Milliseconds 1000
    if( (Test-Path ./ac.txt) -eq "True" ){
        Remove-Item ac.txt                                                        #前回取得時の波形データが残っている場合削除
    }
    [System.Windows.Forms.SendKeys]::SendWait("^s")
    [System.Windows.Forms.SendKeys]::SendWait("{tab}")
    [System.Windows.Forms.SendKeys]::SendWait("{right 4}")
    [System.Windows.Forms.SendKeys]::SendWait("{enter}")
    $retry_cnt = 0
    Set-Clipboard -Value "neko"
    do{
        
        [System.Windows.Forms.SendKeys]::SendWait(".")
        [System.Windows.Forms.SendKeys]::SendWait("^a")
        [System.Windows.Forms.SendKeys]::SendWait("^c")
        start-sleep -Milliseconds 100
        $clip_board = Get-Clipboard -Format Text
        $retry_cnt = $retry_cnt + 1
        if( $retry_cnt -gt 10 ){
            break
        }
    }while( $clip_board -ne "." )
    start-sleep -Milliseconds 10
    [System.Windows.Forms.SendKeys]::SendWait("^a")
    [System.Windows.Forms.SendKeys]::SendWait("^x")
    [System.Windows.Forms.SendKeys]::SendWait("ac.txt")                            #波形データの保存
    [System.Windows.Forms.SendKeys]::SendWait("{enter}")
    start-sleep -Milliseconds 16384                                                #波形取得終了までスリープ

    do{
        $exists = Test-Path ac.txt
    }while( $exists -ne "True" )                                                #ファイルが現れるまで待つ
    
    start-sleep -Milliseconds 1000
    [System.Windows.Forms.SendKeys]::SendWait("{enter}")                        #"Save Data OK!"のダイアログを消す
    start-sleep -Milliseconds 1000
    [System.Windows.Forms.SendKeys]::SendWait("^o")

    $txt = Get-Content ./ac.txt                                                    #波形データの読み込み
    $txt_ch1 = $txt[5..4100]                                                    #ch1分の切り取り
    $sum = 0.0
    $sign = 0
    $sum_sign = 0
    $txt_ch1 | ForEach-Object -Process {
        $sum = $sum + [double]$_*[double]$_                                        #自乗の積分(実効値の算出のため)
        $last_sign = $sign
        if( [double]$_ -ge 0.0 ){
            $sign = 1
        }else{
            $sign = 0
        }
        if( $sign -ne $last_sign ){
            $sum_sign++                                                            #ゼロクロスのカウント
        }
        
    }
    $rms = [math]::sqrt( $sum / 4096.0 )                                         #実効値の算出
    $freq = $sum_sign / (1/250*4096) / 2                                        #周波数の算出
    
    $output_line = $data_point + "    " + [string]$rms + "    " + [string]$freq
    Write-Output $output_line
    Add-Content -Path freq_result.txt -Value $output_line                        #実効値と周波数をファイルに書き出し
    
    Remove-Item ac.txt                                                            #波形データの削除
}
